This module serves as a central place for providing utilities for our python backends.

- **Auth**: Authentication and authorization for APIs with API key and JWT bearer token support
- **Ansi Colors**: ANSI color codes for terminal text formatting and colorful console output
- **Decorators**: Utility decorators for model manipulation, including `partial_model` for optional fields
- **Enums**: Common enumerations for type safety and consistency
- **Errors**: Comprehensive error handling system with HTTP exceptions and error content structures
- **Exceptions**: Custom exception classes and error handling utilities
- **Logging**: Logging configuration and utilities for consistent formatting
- **Middleware**: API middleware components for request/response processing
- **Mixins**: Reusable functionality components for class mixing
- **Pagination**: Utilities for paginated API responses and cursor-based pagination
- **Router**: API routing utilities and components
- **Scopes**: Authorization scope definitions and management for API access control
- **Urls**: URL management utilities including base URLs, service endpoints, and API versioning
- **Utils**: General utility functions and helper methods
- **Warnings**: Warning handling and custom warning types
- **Metrics**: Shared metrics collection from APIs for visualization

# Changelog

<!-- changelog-insertion -->

## v0.1.0 (2025-06-27)


## v0.1.0-rc.1 (2025-06-23)

### Documentation

- Add changelog
  ([`788f1f6`](https://github.com/crypticorn-ai/util-libraries/commit/788f1f670a8a50251401ebd1fc9ab7d2ca855a8d))

- Update Readme
  ([`d2b52cf`](https://github.com/crypticorn-ai/util-libraries/commit/d2b52cfe48de7a8b248ceefbc3bc7007ad21ea72))

### Features

- Initial release
  ([`4da5fe3`](https://github.com/crypticorn-ai/util-libraries/commit/4da5fe3d33abd31b3b35462e93052db0cde077c2))


## Unreleased

### Documentation

- Add changelog
  ([`788f1f6`](https://github.com/crypticorn-ai/util-libraries/commit/788f1f670a8a50251401ebd1fc9ab7d2ca855a8d))

- Update Readme
  ([`d2b52cf`](https://github.com/crypticorn-ai/util-libraries/commit/d2b52cfe48de7a8b248ceefbc3bc7007ad21ea72))
